
!TOClassBrowser methodsFor: '*tode-gemstone-views' stamp: 'dkh 05/27/2011 10:01'!
acessesToCV: classVarName from: aClass
	
	^(SystemNavigation default) allCallsOn: (aClass classPool associationAt: classVarName )
! !

!TOClassBrowser methodsFor: '*tode-gemstone-views' stamp: 'dkh 05/27/2011 10:03'!
acessesToIV: instVarName from: aClass
	| coll |
	coll := OrderedCollection new.
	aClass
		withAllSubAndSuperclassesDo: [ :class | 
			(class whichSelectorsAccess: instVarName)
				do: [ :sel | 
					sel isDoIt
						ifFalse: [ coll add: (MethodReference new class: class selector: sel) ] ] ].
	^ coll! !

!TOClassBrowser methodsFor: '*tode-gemstone-views' stamp: 'dkh 05/27/2011 10:05'!
classDefinitionTemplate: classTemplateType
	| stream |
	classTemplateType == #new
		ifTrue: [ ^ Class templateForSubclassOf: Object name category: self theClass theNonMetaClass category ].

	classTemplateType == #subclass
		ifTrue: [ ^ Class templateForSubclassOf: self theClass name category: self theClass theNonMetaClass category ].
		
	"classTemplateType == #definition"
	stream := WriteStream on: String new.
	stream
		nextPutAll: self theClass definition;
		nextPut: $.;
		cr.
	^ stream contents! !

!TOClassBrowser methodsFor: '*tode-gemstone-views' stamp: 'dkh 05/27/2011 10:06'!
copyClass: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-gemstone-views' stamp: 'dkh 05/27/2011 10:07'!
removeClass: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-gemstone-views' stamp: 'dkh 05/27/2011 10:07'!
renameClass: s id: id
	(s << (s jQuery id: id) dialog) open.
	TOAbortCommand signal! !

!TOClassBrowser methodsFor: '*tode-gemstone-views' stamp: 'dkh 05/27/2011 10:16'!
renderClassExplorerOn: html main: main
	self
		renderControl: [ :id :scrpt | 
			html break.
			self
				renderLink: [ :s | 
					| frame |
					frame := main currentSpace push: self theClass superclass allCallsOn.
					frame selectedCenterTab: #inspect.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass superclass name ]
				on: html.
			html text: ' subclass: '.
			self
				renderLink: [ :s | 
					| frame |
					frame := main currentSpace push: self theClass allCallsOn.
					frame selectedCenterTab: #inspect.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass name ]
				on: html.
			html
				unorderedList: [ 
					html text: 'instanceVariableNames: '.
					self theClass instVarNames
						do: [ :iv | 
							html space.
							self
								renderLink: [ :s | 
									| frame |
									frame := main currentSpace push: (self acessesToIV: iv from: self theClass).
									frame selectedCenterTab: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: iv ]
								on: html ] ].
			html
				unorderedList: [ 
					html text: 'classVariableNames: '.
					self theClass classVarNames
						do: [ :cv | 
							html space.
							self
								renderLink: [ :s | 
									| frame |
									frame := main currentSpace push: (self acessesToCV: cv from: self theClass).
									frame selectedCenterTab: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: cv ]
								on: html ] ].
			html
				unorderedList: [ 
					html text: 'poolDictionaries: '.
					self theClass theNonMetaClass poolDictionaryNames
						do: [ :sp | 
							html strong: sp ] ].
			html
				unorderedList: [ 
					| cat |
					html text: 'category: '.
					cat := self theClass theNonMetaClass category.
					self
						renderLink: [ :s | 
							| frame |
							frame := main currentSpace push: ((
		(SystemOrganizer new listAtCategoryNamed: cat)
			collect: [:className | Smalltalk classNamed: className])
				sortBy: [:a :b | a className <= b className]).
							frame selectedCenterTab: #inspect.
							main updateCenterSideHistory: s ]
						with: [ html strong: cat ]
						on: html ].
			html break.
			self
				renderLink: [ :s | 
					| frame |
					frame := main currentSpace push: self theClass class allCallsOn.
					frame selectedCenterTab: #inspect.
					main updateCenterSideHistory: s ]
				with: [ html strong: self theClass name , ' class' ]
				on: html.
			html break.
			html
				unorderedList: [ 
					html text: 'instanceVariableNames: '.
					self theClass class instVarNames
						do: [ :iv | 
							html space.
							self
								renderLink: [ :s | 
									| frame |
									frame := main currentSpace push: (self acessesToIV: iv from: self theClass).
									frame selectedCenterTab: #inspect.
									main updateCenterSideHistory: s ]
								with: [ html strong: iv ]
								on: html ] ] ]
		on: html! !

!TOMethodCategoryBrowser methodsFor: '*tode-gemstone-views' stamp: 'dkh 05/27/2011 10:20'!
selectorsForCategory: cat

	^(cat = '-- all --'
		ifTrue: [ self theClass selectors ]
		ifFalse: [ self theClass selectorsIn: cat ]) asArray.! !

!TOMethodCategoryBrowser methodsFor: '*tode-gemstone-views' stamp: 'dkh 05/27/2011 10:22'!
sortedCategories

	^self theClass categoryNames asArray sorted: [:a :b | a <= b ].! !
